--- lrb_prototype_primitives.inl	2010-06-15 17:01:51.147217886 +0200
+++ lrbni_prototypes.h	2010-06-15 17:01:22.767217213 +0200
@@ -5364,10 +5388,10 @@
 inline _M512I _mm512_mask_insertfield_pi(_M512I v1_old, __mmask k1, _M512I v2, _M512I v3, _MM_BITPOSITION32_ENUM rotation, _MM_BITPOSITION32_ENUM bit_idx_low, _MM_BITPOSITION32_ENUM bit_idx_high)
 {
     _M512I result;
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
     unsigned int maskRight = 0xFFFFFFFF >> (31 - bit_idx_high);
     unsigned int maskLeft = 0xFFFFFFFF << bit_idx_low;
     unsigned int mask;
@@ -5396,14 +5420,14 @@
     _M512 result;
     int size, i;
     
-    int *r = (int *) &result;
+    _LPP_Int *r = (_LPP_Int *) &result;
 
     size = _LPP_FullUpConvSize(full_up);
 
     switch(broadcast) {
         case _MM_BROADCAST_16X16:
             for (i=0; i < 16; i++) {
-                r[i] = _LPP_FullUpConv((void *) ((char *) m + i*size), full_up);
+                r[i] = _LPP_FullUpConv((void *) ((_LPP_Char *) m + i*size), full_up);
             }
        break;
         case _MM_BROADCAST_1X16:
@@ -5413,7 +5437,7 @@
         break;
         case _MM_BROADCAST_4X16:
             for (i=0; i < 16; i++) {
-                r[i] = _LPP_FullUpConv((void *) ((char *) m + (i % 4) * size), full_up);
+                r[i] = _LPP_FullUpConv((void *) ((_LPP_Char *) m + (i % 4) * size), full_up);
             }
         break;
     }
@@ -5426,8 +5450,8 @@
     _M512 result;
     int size, i;
     
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
 
     size = _LPP_FullUpConvSize(full_up);
 
@@ -5435,7 +5459,7 @@
         case _MM_BROADCAST_16X16:
             for (i=0; i < 16; i++) {
                 if (k1 & 1) {
-                    r[i] = _LPP_FullUpConv((void *) ((char *) m + i*size), full_up);
+                    r[i] = _LPP_FullUpConv((void *) ((_LPP_Char *) m + i*size), full_up);
                 } else {
                     r[i] = p1[i];
                 }
@@ -5455,7 +5479,7 @@
         case _MM_BROADCAST_4X16:
             for (i=0; i < 16; i++) {
                 if (k1 & 1) {
-                    r[i] = _LPP_FullUpConv((void *) ((char *) m + (i % 4) * size), full_up);
+                    r[i] = _LPP_FullUpConv((void *) ((_LPP_Char *) m + (i % 4) * size), full_up);
                 } else {
                     r[i] = p1[i];
                 }
@@ -5471,8 +5495,8 @@
 {
     _M512 result;
     
-    int64_t *r = (int64_t *) &result;
-    int64_t *src = (int64_t *) m;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *src = (_LPP_Int64 *) m;
 
     switch(broadcast) {
         case _MM_BROADCAST_8X8:
@@ -5499,9 +5523,9 @@
 {
     _M512 result;
     
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *src = (int64_t *) m;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *src = (_LPP_Int64 *) m;
 
     switch(broadcast) {
         case _MM_BROADCAST_8X8:
@@ -5543,8 +5567,8 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    char *src = (char *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Char *src = (_LPP_Char *) m;
     int size = _LPP_FullUpConvSize(full_up);
 
     for (int i=0; i < 16; i++) {
@@ -5559,9 +5583,9 @@
 {
     _M512 result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    char *src = (char *) m;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Char *src = (_LPP_Char *) m;
     int size = _LPP_FullUpConvSize(full_up);
 
     for (int i=0; i < 16; i++) {
@@ -5581,8 +5605,8 @@
 {
     _M512 result;
 
-    int64_t *r = (int64_t *) &result;
-    int64_t *src = (int64_t *) m;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *src = (_LPP_Int64 *) m;
 
     for (int i=0; i < 8; i++) {
         r[i] = *src++;
@@ -5595,9 +5619,9 @@
 {
     _M512 result;
 
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *src = (int64_t *) m;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *src = (_LPP_Int64 *) m;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5616,10 +5640,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p1[i] * p3[i]) + p2[i];
@@ -5643,10 +5667,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5680,10 +5704,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p1[i] * p3[i]) + p2[i];
@@ -5707,10 +5731,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5744,10 +5768,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p2[i] * p1[i]) + p3[i];
@@ -5771,10 +5795,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5808,10 +5832,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p1[i]) + p3[i];
@@ -5835,10 +5859,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5872,10 +5896,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p2[i] * p3[i]) + p1[i];
@@ -5899,10 +5923,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -5935,10 +5959,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p3[i]) + p1[i];
@@ -5951,10 +5975,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -5973,10 +5997,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p3[i]) + p1[i];
@@ -6000,10 +6024,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6036,9 +6060,9 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p3[(i & 0x0C) + 1]) + p3[(i & 0x0C) + 0];
@@ -6051,10 +6075,10 @@
 {
     _M512I result;
 
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6073,9 +6097,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p3[(i & 0x0C) + 1]) + p3[(i & 0x0C) + 0];
@@ -6100,10 +6124,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6139,10 +6163,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = -((p1[i] * p3[i]) + p2[i]);
@@ -6167,10 +6191,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -6205,10 +6229,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = -((p1[i] * p3[i]) + p2[i]);
@@ -6233,10 +6257,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6271,10 +6295,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = -((p2[i] * p1[i]) + p3[i]);
@@ -6299,10 +6323,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -6337,10 +6361,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = -((p2[i] * p1[i]) + p3[i]);
@@ -6365,10 +6389,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6403,10 +6427,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = -((p2[i] * p3[i]) + p1[i]);
@@ -6431,10 +6455,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -6469,10 +6493,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = -((p2[i] * p3[i]) + p1[i]);
@@ -6497,10 +6521,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6535,9 +6559,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_max(fabs(p2[i]), fabs(p3[i]));
@@ -6561,10 +6585,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6599,9 +6623,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_max(p2[i], p3[i]);
@@ -6624,10 +6648,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -6661,9 +6685,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_max(p2[i], p3[i]);
@@ -6687,10 +6711,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6725,9 +6749,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_max(p2[i], p3[i]);
@@ -6750,10 +6774,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6786,9 +6810,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_max(p2[i], p3[i]);
@@ -6801,10 +6825,10 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6823,9 +6847,9 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = _LPP_min(p2[i], p3[i]);
@@ -6848,10 +6872,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1_old;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1_old;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -6885,9 +6909,9 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_min(p2[i], p3[i]);
@@ -6911,10 +6935,10 @@
     _M512I result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    int *r = (int *) &result;
-    int *p1 = (int *) &v1_old;
-    int *p2 = (int *) &v2;
-    int *p3 = (int *) &v3;
+    _LPP_Int *r = (_LPP_Int *) &result;
+    _LPP_Int *p1 = (_LPP_Int *) &v1_old;
+    _LPP_Int *p2 = (_LPP_Int *) &v2;
+    _LPP_Int *p3 = (_LPP_Int *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -6949,9 +6973,9 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_min(p2[i], p3[i]);
@@ -6974,10 +6998,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1_old;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1_old;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7010,9 +7034,9 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = _LPP_min(p2[i], p3[i]);
@@ -7031,9 +7055,9 @@
 {
     _M512 result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7051,9 +7075,9 @@
 {
     _M512 result;
 
-    int64_t *r = (int64_t *) &result;
-    int64_t *p1 = (int64_t *) &v1_old;
-    int64_t *p2 = (int64_t *) &v2;
+    _LPP_Int64 *r = (_LPP_Int64 *) &result;
+    _LPP_Int64 *p1 = (_LPP_Int64 *) &v1_old;
+    _LPP_Int64 *p2 = (_LPP_Int64 *) &v2;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7071,10 +7095,10 @@
 {
     _M512I result;
 
-    unsigned int *r = (unsigned int *) &result;
-    unsigned int *p1 = (unsigned int *) &v1_old;
-    unsigned int *p2 = (unsigned int *) &v2;
-    unsigned int *p3 = (unsigned int *) &v3;
+    _LPP_UInt *r = (_LPP_UInt *) &result;
+    _LPP_UInt *p1 = (_LPP_UInt *) &v1_old;
+    _LPP_UInt *p2 = (_LPP_UInt *) &v2;
+    _LPP_UInt *p3 = (_LPP_UInt *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7093,10 +7117,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p1[i] * p3[i]) - p2[i];
@@ -7120,10 +7144,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7157,10 +7181,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p1[i] * p3[i]) - p2[i];
@@ -7184,10 +7208,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7221,10 +7245,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p2[i] * p1[i]) - p3[i];
@@ -7248,10 +7272,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7285,10 +7309,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p1[i]) - p3[i];
@@ -7312,10 +7336,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
@@ -7349,10 +7373,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         r[i] = (p2[i] * p3[i]) - p1[i];
@@ -7376,10 +7400,10 @@
     _M512D result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    double *r = (double *) &result;
-    double *p1 = (double *) &v1;
-    double *p2 = (double *) &v2;
-    double *p3 = (double *) &v3;
+    _LPP_Double *r = (_LPP_Double *) &result;
+    _LPP_Double *p1 = (_LPP_Double *) &v1;
+    _LPP_Double *p2 = (_LPP_Double *) &v2;
+    _LPP_Double *p3 = (_LPP_Double *) &v3;
 
     for (int i=0; i < 8; i++) {
         if (k1 & 1) {
@@ -7413,10 +7437,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         r[i] = (p2[i] * p3[i]) - p1[i];
@@ -7440,10 +7464,10 @@
     _M512 result;
 
 #if USE_C_PROTOTYPE_PRIMITIVES
-    float *r = (float *) &result;
-    float *p1 = (float *) &v1;
-    float *p2 = (float *) &v2;
-    float *p3 = (float *) &v3;
+    _LPP_Float *r = (_LPP_Float *) &result;
+    _LPP_Float *p1 = (_LPP_Float *) &v1;
+    _LPP_Float *p2 = (_LPP_Float *) &v2;
+    _LPP_Float *p3 = (_LPP_Float *) &v3;
 
     for (int i=0; i < 16; i++) {
         if (k1 & 1) {
